	ORG	$06000

***************************************************
**						 **
**     ROLLING THUNDER -    THE AMIGA VERSION	 **
** 						 **
**     D.CAMPBELL             TIERTEX LIMITED	 **
**						 **
***************************************************

*
*	START OF THE REAL PROGRAM
*	
START	LEA	DATAS,A1
	MOVE.L	A0,(A1)				SAVE START OF DATA
	MOVE.L	#8,A2				START WITH BUS ERRORS
	MOVE	#48,D0
	LEA	INTERR,A1
*STARTL	MOVE.L	A1,(A2)+
*	DBRA	D0,STARTL
	MOVE.L	#SSPA7,SP			JUST IN CASE
	MOVE.L	#SSPA7,A7			RE-ITTERATE STACK
	LEA	BLACK,A0
	BSR	SETCOL
	LEA	STACKP,A0
	MOVE.L	A7,(A0)
	BRA	START2

	EVEN
STACKP	DC.L	0
COLOUR3	dc.w	$050
COLOURX	DC.W	$531

INTERR	MOVEM.L	D0/A0-A2,-(SP)
	LEA	COLOURC,A0
	BSR	SETCOL
	MOVEM.L	(SP)+,D0/A0-A2
	RTE
COLOURC	DC.W	$220				DARK YELLOW


*
*	MAIN EQUATES
*
PROGRAM	EQU	$06000
CUSTOM	EQU	$DFF000
BPLCON0	EQU	$100
BPLCON1	EQU	$102
BPL1MOD	EQU	$108
DDFSTRT	EQU	$092
DDFSTOP	EQU	$094
DIWSTRT	EQU	$08E
DIWSTOP	EQU	$090
VPOSR	EQU	$004
COLOURS	EQU $180
DMACON	EQU	$096
COP1LCH	EQU	$080
COPJMP1	EQU	$088
INTENA	EQU	$09A				INTERRUPT ENABLE MASK
INTREQ	EQU	$09C
JOYDAT1	EQU	$00C
USPA7	EQU	$02000		AT 8K
SSPA7	EQU	$04000		AT 16K
SCREEN1	EQU	$68000
SCREEN2	EQU	$70000
SCREEN3	EQU	$78000		TRI SCREEN (C) TIERTEX LTD
MAIN	EQU	$10000
SPRITED	EQU	$30000	
REVERSE	EQU	$40000
STACK	EQU	$50000		FOR NOW OK			
SPRLEN	EQU	63840		
NSPRITE	EQU	95		95*42*16 = 63840
CHRSET	EQU	$18000		FOR NOW
CHRLEN	EQU	85200
FIRST	EQU	PROGRAM		AS WAS BEFORE
MAP1	EQU CHRSET+51200
MAP2	EQU	CHRSET+60800
MAP3	EQU	CHRSET+71200
MAP4	EQU	CHRSET+74400
MAP5	EQU	CHRSET+82000
MAPE	EQU	CHRSET+85200

SS	EQU	$17F90			IN SAVED SCREEN SOMWHERE
SONOFF	EQU	SS+4			SOUND ON-0 OFF-255
PLAYERS	EQU	SS+6			TOTAL NUMBER OF PLAYERS	
PLAYWHO	EQU	SS+8			CURRENT PLAYERS
SCREENX	EQU	SS+10			ONLY USED BY NEWSC AND SCROLL
SCREENY	EQU	SS+12
SCRX	EQU	SS+14			2*VALUES AS USED IN OTHER CONVS.
SCRY	EQU	SS+16
SCROLLB	EQU	SS+26
PARAMS	EQU	SS+28
HALF	EQU	SS+30
HALFC	EQU	SS+32
MOVCTR	EQU	SS+34
SPX	EQU	SS+38
SPY	EQU	SS+40
SCX	EQU	SS+42
SCY	EQU	SS+44
OFFSET	EQU	SS+46
HIGHT	EQU	SS+48
PLANES	EQU	SS+50	
BLOCKD	EQU	SS+52
BLOCKL	EQU	SS+54
BLOCKR	EQU	SS+56
BLOCKDL	EQU	SS+58
BLCKDL	EQU	SS+58			SPELLING ERRORS
BLOCKDR	EQU	SS+60
BLCKDR	EQU	SS+60			DITTO
RHORZ	EQU	SS+62
RVERT	EQU	SS+64
RDIR	EQU	SS+66
NOISE	EQU	SS+68
CHEAT	EQU	SS+70
PIXEL	EQU	SS+72
LINE	EQU	SS+74
TPIXEL	EQU	SS+76
TLINE	EQU	SS+78


MWIDE	EQU	400			2*200 ACROSS

	EVEN
CURMAP	DC.L	0			FOR NOW
BMAP	DC.L	0
DMAP	DC.L	0
PMAP	DC.L	0
WMAP	DC.L	MAP1,MAP2,MAP3,MAP4,MAP5,MAP1,MAP2,MAP3,MAP4,MAP5

*
*	SCORES PLAYER 1 AND PLAYER 2, 1ST THREE BYTES NAME
*
SCORE1	DC.B	"000000",0
SCORE2	DC.B	"000000",0
HIGH	DC.B	"010000",0
BULLET1	DC.B	"000",0
BULLET2	DC.B	"000",0
MGBLT1	DC.B	"000",0
MGBLT2	DC.B	"000",0
MEN1	DC.B	"0",0
MEN2	DC.B	"0",0
TIME	DC.B	"000",0
LIFE	DC.B	"ZZZZZZ",0
	EVEN
LIFEC	DC.W	0,0
*
*	GENERAL BITS AND BOBS
*	IF D0 IS LOADED WITH PLAYWHO 0 OR 2, THEN USE (A0,D0.W)
*
	EVEN
SHEET	DC.W	0,0	CURRENT SHEET
BONE	DC.W	0,0	BONUS INDICATORS
HALFW	DC.W	0,0	HALFWAY OR NOT
NHALF	DC.W	0,0	NEXT HALF WAY POINT
IMPOSS	DC.W	0,0	PASSED AREAD 10

*
*	MAIN VARIABLES AND STORES
*
	EVEN
SCREEN	DC.L	0
WORKS	DC.L	0
INTER	DC.L	0			INTERMEDIATE SCREEN
DATAS	DC.L	0

*
*	1ST LEVEL PROGRAM LOOP
*
START2	LEA	STACKP,A0
	MOVE.L	(A0),A7			SET-UP STACK
	BSR	COLD			COLD RESET
RESET	LEA	STACKP,A0
	MOVE.L	(A0),SP			CAN JUMP HERE ANY TIME/PLACE
GAMEL	BSR	INTRO			INTRO SHEET
	BSR	WARM			NEW GAME START

	MOVE	#255,CHEAT		CHEAT MODE ON !

GAMELS	BSR	GO			NEW GO START
INGAMEL	BSR	PLAY
	LEA	TABLE,A6
	CMPI	#128,STATUS(A6)
	BEQ	ING1
	BSR	LOSLIFE
	BRA	GAMELS
ING1	BSR	INCLEV
	BRA	GAMELS

*
*	COLD INTIALISATION - RUN ONLY ONCE
*
COLD	nop
*	nop	BSR	VECTORS			DO VECTORS
	LEA	MAIN,A0
	LEA	DATAS,A6
	MOVE.L	(A6),A1
	ADD.L	#32768+35,A1		GET RID OF DEGAS BIT odd i know
	MOVE	#31999,D0		A SCREEN WORTH
RELOC2	MOVE.B	(A1)+,(A0)+
	DBRA	D0,RELOC2
	MOVE.L	(A6),A1
	ADD.L	#32044+32768,A1
	MOVE	#CHRLEN/2-1,D0
	LEA	CHRSET,A0
RELOC3	MOVE	(A1)+,(A0)+
	DBRA	D0,RELOC3
	MOVE.L	(A6),A1
	ADD.L	#32044+CHRLEN+32768,A1
	LEA	SPRITED,A0
	MOVE	#SPRLEN/2-1,D0
RELOC4	MOVE	(A1)+,(A0)+
	DBRA	D0,RELOC4		ALL RELOCATED
	MOVE.L	#SS,A0
	MOVE	#100,D0
COLD0	CLR	(A0)+
	DBRA	D0,COLD0		RESET ALL VARIABLES IN ABS STORE
	LEA	CUSTOM,A0		SET UP SCREEN PARAMS
	MOVE	#$4200,BPLCON0(A0)
	MOVE	#$0,BPLCON1(A0)
	MOVE	#$0,BPL1MOD(A0)
	MOVE	#$0038,DDFSTRT(A0)
	MOVE	#$00D0,DDFSTOP(A0)
	MOVE	#$2C81,DIWSTRT(A0)
	MOVE	#$F4C1,DIWSTOP(A0)
	LEA	COPPER1,A6
	MOVE.L	A6,COP1LCH(A0)		SET-UP FIRST COPPER
	MOVE	COPJMP1(A0),D0		STROBE
	MOVE	#$8380,DMACON(A0)	SET DMA CORRECTLY
	CLR	NOISE
	LEA	SCREEN,A1
	MOVE.L	#SCREEN1,0(A1)
	MOVE.L	#SCREEN2,4(A1)
	MOVE.L	#SCREEN3,8(A1)
	BSR	GETADD			GENERATE SPRITE ADDRESSES
	BSR	REVTAB			GENERATE REV SPRITES
	LEA	PLAYERS,A0
	MOVE.W	#00,(A0)		ONE PLAYER MODE
	LEA	SONOFF,A0
	MOVE.W	#01,(A0)		SOUND INITIALLY OFF
	MOVE	#500,D0
	BSR	DELAY
	LEA	SONOFF,A0
	CLR	(A0)			PUT SOUND ON
	BSR	CLEARK
BODGE  	LEA	MAP1,A0			GET RID OF CHRS WITH > VAL 400
BODGE1	CMPI	#400,(A0)+
	BCS	BODGE2
	MOVE	#61,-2(A0)
BODGE2	CMP.L	#MAPE,A0
	BCS	BODGE1
	RTS

*
*	WARM RESET - EXECUTE EVERY NEW GAME ONLY ONCE
*
WARM	LEA	MEN1,A1
	MOVE.B	#"5",(A1)
	MOVE.B	#"5",2(A1)		SET UP STRINGS
	LEA	SHEET,A0
	MOVE	#0,0(A0)		SHEETs
	MOVE	#0,2(A0)
	LEA	HALFW,A0
	MOVE	#0,0(A0)
	MOVE	#0,2(A0)
	LEA	SCORE1,A0
	MOVE	#5,D0
WARM1	MOVE.B	#"0",0(A0,D0.W)
	MOVE.B	#"0",7(A0,D0.W)
	DBRA	D0,WARM1
	LEA	PLAYWHO,A0		PLAYERS SET UP IN IN