SUBQ.W	#1,D0
	BNE	INCGEN2
	RTS
INCGEN3	ADDQ.B	#1,0(A2,D1.W)
	CMPI.B	#"!",0(A2,D1.W)		I.E. IT WAS A SPACE
	BNE	INCGEN5
	MOVE.B	#"1",0(A2,D1.W)
	RTS
INCGEN5	CMPI.B	#":",0(A2,D1.W)
	BNE	INCGEN4
	MOVE.B	#"0",0(A2,D1.W)		
	SUBQ.W	#1,D1
	BPL	INCGEN3			TEST FOR UNDERFLOW CONDITION
INCGEN4	RTS

INCR	TST.B	0(A0)
	BNE	INCR0
	RTS
INCR0	ADD.B	D0,0(A0)
	CMPI.B	#"9"+1,0(A0)
	BCC	INCR1
	RTS
INCR1	MOVE.B	#"0",0(A0)
	SUBQ.L	#1,A0
	MOVEQ	#1,D0
	BRA	INCR

DECR	TST.B	0(A0)
	BNE	DECR0
	RTS
DECR0	SUB.B	D0,0(A0)
	CMPI.B	#"0",0(A0)
	BCS	DECR1
	RTS
DECR1	MOVE.B	#"9",0(A0)
	SUBQ.L	#1,A0
	MOVEQ	#1,D0
	BRA	DECR

REVTAB	MOVE	#NSPRITE-1,D7			DO IT FOR 95 SPRITES
	LEA	SPRITED,A0
	LEA	REVERSE,A1
REV1	MOVE	#41,D6			SIZE OF SPRITE
REV2	MOVE	#0,D0
	MOVE	#8,D1			RIGHT AND LEFT
	BSR	ROTATE
	BSR	ROTATE
	BSR	ROTATE
	BSR	ROTATE
	MOVE	#8,D0
	MOVE	#0,D1
	BSR	ROTATE
	BSR	ROTATE
	BSR	ROTATE
	BSR	ROTATE
	ADD.L	#16,A0
	ADD.L	#16,A1
	DBRA	D6,REV2
	DBRA	D7,REV1
	RTS
ROTATE	MOVE	0(A0,D0),D3
	MOVE	#15,D5
ROT1	LSL	#1,D3
	ROXR	#1,D4
	DBRA	D5,ROT1
	MOVE	D4,0(A1,D1)
	ADD	#2,D0
	ADD	#2,D1
	RTS

LIFED	TST	CHEAT
	BNE	LIFEDE
	LEA	LIFEC,A0
	TST	2(A0)
	BEQ	LIFEDE
	TST	(A0)
	BEQ	LIFEDE
	SUBQ	#1,2(A0)
	TST	2(A0)
	MOVE	#7,NOISE
	BEQ	LFD1
	CMPI	#3,2(A0)
	BEQ	LFD1
	BRA	LFD11
LFD1	CLR	(A0)				; FLAG OFF
LFD11	MOVE.B	#"9"+7,D1
	MOVE	2(A0),D0
	LEA	LIFE,A0
	MOVE	#5,D2
LFD2	TST	D0
	BNE	LFD3
	MOVE.B	#" ",D1
LFD3	MOVE.B	D1,(A0)+
	SUBQ	#1,D0
	DBRA	D2,LFD2
	BRA	UPDATE
LIFEDE	RTS

NEWHI	LEA	SCORE1,A0
	BSR	NEWHI1
	LEA	SCORE2,A0
NEWHI1	LEA	HIGH,A1
	CLR	D0
NEWHI2	MOVE.B	0(A1,D0),D1
	CMP.B	0(A0,D0),D1
	BCS	NEWHI3
	BNE	NEWHIE
	ADDQ	#1,D0
	CMPI	#6,D0
	BNE	NEWHI2
NEWHIE	RTS
NEWHI3	MOVEQ	#5,D0
NEWHI4	MOVE.B	(A0)+,(A1)+
	DBRA	D0,NEWHI4
	RTS
	INCDIR	"DF1:"
	EVEN
	INCLUDE	SCREEN.S
	EVEN
	INCLUDE ANIMATE.S
	EVEN
	INCLUDE	MOVING.S
	EVEN
	INCLUDE FOOTING.S
	EVEN
	INCLUDE	SOUND.S
	EVEN
	INCLUDE MASK.S
	EVEN
	INCLUDE	DATA.S
	EVEN
	
	DC.B	"END OF ROLLING THUNDER"
	DC.B	"TIERTEX LTD. 1987 DONALD CAMPBELL"


	include	libraries/dos_lib.i	and DOS
	include	libraries/dos.i

* start by opening the DOS library
TOPBIT	LEA	dosname,A1
	MOVEQ	#0,d0			any version
	CALLEXEC OpenLibrary
	move.l	d0,_DOSBase		save pointer
	MOVE.L	#SPRLEN+CHRLEN+32044+32768+1000,D0
	MOVE.L	#MEMF_CHIP,D1
	CALLEXEC AllocMem
	LEA	MEMORY,A0
	ADD.L	#10,D0
	BCLR	#0,D0			WORD ALIGNED
	MOVE.L	D0,(A0)			SAVE MEMORY POINTER
	LEA	MEMORY,A0
	MOVE.L	(A0),A1
	LEA	FILE0,A0
	MOVE.L	#32768,D0
	BSR	DLOAD
	LEA	MEMORY,A0
	MOVE.L	(A0),A1
	ADD.L	#32768,A1
	LEA	FILE1,A0
	MOVE.L	#32044,D0
	BSR	DLOAD
	LEA	MEMORY,A0
	MOVE.L	(A0),A1
	ADD.L	#32044+32768,A1		OFFSET TO START OF CHRS
	LEA	FILE2,A0
	MOVE.L	#CHRLEN,D0
	BSR	DLOAD
	LEA	MEMORY,A0
	MOVE.L	(A0),A1
	ADD.L	#32044+CHRLEN+32768,A1
	LEA	FILE3,A0
	MOVE.L	#SPRLEN,D0
	BSR	DLOAD
	MOVE	#4000,D0
	BSR	DELAY			GET DRIVE OFF
*	CALLEXEC SuperState		into supervisory
	LEA	CUSTOM,A0
	MOVE	#$4000,INTENA(A0)	ALL INTERRUPTS OFF
	MOVE	#$7FFF,DMACON(A0)	ALL DMA OFF
	LEA	MEMORY,A0
	MOVE.L	(A0),A0
FINDP	CMPI	#$43F9,(A0)
	BEQ	FOUND
	ADDQ.L	#2,A0
	BRA	FINDP
FOUND	LEA	PROGRAM,A1
	MOVE	#16383,D0		PROGRAM LENGTH/2
RELOC1	MOVE	(A0)+,(A1)+		TO BEGINING OF MEMORY
	DBRA	D0,RELOC1
	LEA	MEMORY,A0
	MOVE.L	(A0),A0			A0 HOLDS ADDRESS OF DATA
	LEA	PROGRAM,A6
	JMP	(A6)			JUMP TO START

* open a file, A0 FILE NAME, A1 START ADDRESS, D0 - LENGTH
	EVEN
FILEL	DC.L	0
LENGTH	DC.L	0
HANDLE	DC.L	0
DLOAD	LEA	FILEL,A6
	MOVE.L	A1,(A6)
	MOVE.L	D0,4(A6)
	MOVE.L	A0,D1
	MOVE.L	#MODE_OLDFILE,D2	file just loading
	CALLDOS	Open
	LEA	HANDLE,A0
	MOVE.L	D0,(A0)			SAVE FILE HANDLE
	MOVE.L	D0,D1
	LEA	FILEL,A0
	MOVE.L	(A0),D2			START ADDRESS
	MOVE.L	4(A0),D3		AND LENGTH
	CALLDOS	Read
	LEA	HANDLE,A0
	MOVE.L	(A0),D1
	CALLDOS	Close
	RTS

DELAY	MOVE	#799,D1
DEL1	DBRA	D1,DEL1
	DBRA	D0,DELAY
	RTS

dosname	DOSNAME				defines dos name

_DOSBase	DC.L	0		space for pointer
MEMORY	DC.L	0
FILE0	DC.B	"DF1:GAME",0
FILE1	DC.B	"DF1:MAINR.PI1",0
FILE2	DC.B	"DF1:ROLLING.DTA",0
FILE3	DC.B	"DF1:SPRITES.DTA",0
),A0
FINDP	CMPI	#$43F9,(A0)
	BEQ	FOUND
	ADDQ.L	#2,A0
	BRA	FINDP
FOUND	LEA	PROGRAM,A1
	MOVE	#16383,D0		PROGRAM LENGTH/2
RELOC1	MOVE	(A0)+,(A1)+		TO BEGINING OF MEMORY
	DBRA	D0,RELOC1
	LEA	MEMORY,A0
	MOVE.L	(A0),A0			A0 HOLDS ADDRESS OF DATA
	LEA	PROGRAM,A6
	JMP	(A6)			JUMP TO START

* open a file, A0 FILE NAME, A1 START ADDRESS, D0 - LENGTH
	EVEN
FILEL	DC.L	0
LENGTH	DC.L	0
HANDLE	DC.L	0
DLOAD	LEA	FILEL,A6
	MOVE.L	A1,(A6)
	MOVE.L	D0,4(A6)
	MOVE.L	A0,D1
	MOVE.L	#MODE_OLDFILE,D2	file just loading
	
	include	libraries/dos_lib.i	and DOS
	include	libraries/dos.i

* start by opening the DOS library
TOPBIT	LEA	dosname,A1
	MOVEQ	#0,d0			any version
	CALLEXEC OpenLibrary
	move.l	d0,_DOSBase		save pointer
	MOVE.L	#SPRLEN+CHRLEN+32044+32768+1000,D0
	MOVE.L	#MEMF_CHIP,D1
	CALLEXEC AllocMem
	LEA	MEMORY,A0
	ADD.L	#10,D0
	BCLR	#0,D0			WORD ALIGNED
	MOVE.L	D0,(A0)			SAVE MEMORY POINTER
	LEA	MEMORY,A0
	MOVE.L	(A0),A1
	LEA	FILE0,A0
	MOVE.L	#32768,D0
	BSR	DLOAD
	LEA	MEMORY,A0
	MOVE.L	(A0),A1
	ADD.L	#32768,A1
	LEA	FILE1,A0
	MOVE.L	#32044,D0
	BSR	DLOAD
	LEA	MEMORY,A0
	MOVE.L	(A0),A1
	ADD.L	#32044+32768,A1		OFFSET TO START OF CHRS
	LEA	FILE2,A0
	MOVE.L	#CHRLEN,D0
	BSR	DLOAD
	LEA	MEMORY,A0
	MOVE.L	(A0),A1
	ADD.L	#32044+CHRLEN+32768,A1
	LEA	FILE3,A0
	MOVE.L	#SPRLEN,D0
	BSR	DLOAD
	MOVE	#4000,D0
	BSR	DELAY			GET DRIVE OFF
*	CALLEXEC SuperState		into supervisory
	LEA	CUSTOM,A0
	MOVE	#$4000,INTENA(A0)	ALL INTERRUPTS OFF
	MOVE	#$7FFF,DMACON(A0)	ALL DMA OFF
	LEA	MEMORY,A0
	MOVE.L	(A
	
*	THE END OF GAME SEQUENCE
*
GAMEND	BSR	NEWHI
	MOVE	#10,LINE		NO LAUGHING
	LEA	COLOURI,A0
	BSR	SETCOL
	MOVE	#34,D7
GAMENDL	MOVE	D7,-(SP)
	BSR	UNDRAW			DRAW WITHOUT FLIPS
	BSR	ANIMS
	BSR	FLIPS
	MOVE.L	#160*12*8+48,A0
	LEA	GSTR1,A1
	BSR	SPRINT
	MOVE	#25,D0		2.5 SECONDS
	BSR	DELAY
	MOVE	(SP)+,D7
	DBRA	D7,GAMENDL
	BRA	RESET
GSTR1	DC.B	'   GAME  OVER   ',0

*
*	INCREMENT LEVEL PROCEDURE
*
INCLEV	BSR	BONUS
	LEA	HALFW,A0
	MOVE	PLAYWHO,D7
	CLR	0(A0,D7)
	MOVE	#10,LINE		NO LAUGHING
	LEA	COLOURI,A0
	BSR	SETCOL
	MOVE	#20,D7
INCLOOP	MOVE	D7,-(SP)
	BSR	UNDRAW			DRAW WITHOUT FLIPS
	BSR	ANIMS
	BSR	FLIPS
	MOVE.L	#160*12*8+48,A0
	LEA	INCSTR1,A1
	MOVE	PLAYWHO,D7
	LSR	#1,D7
	ADD.B	#"1",D7
	MOVE.B	D7,11(A1)
	BSR	SPRINT
	MOVE.L	#160*13*8+48,A0
	LEA	INCSTR2,A1
	MOVE.B	#" ",5(A1)
	MOVE	SHEET,D7
	ADD	#"1",D7
	MOVE.B	D7,6(A1)
	CMPI.B	#"9"+1,D7
	BNE	INLEV1
	MOVE.B	#"1",5(A1)
	MOVE.B	#"0",6(A1)
INLEV1	BSR	SPRINT
	MOVE	#25,D0		1.5 SECONDS TOTAL
	BSR	DELAY
	MOVE	(SP)+,D7
	DBRA	D7,INCLOOP
	ADD	#1,SHEET
	CMPI	#10,SHEET
	BNE	INCLEVB
	CLR	SHEET
	LEA	IMPOSS,A0
	MOVE	PLAYWHO,D7
	MOVE	#255,0(A0,D7)		IMPOSSIBLE FROM NOW ON IN
INCLEVB	MOVE	PLAYWHO,D7
	LEA	MEN1,A0
	TST	D7
	BEQ	INCLEVA
	LEA	MEN2,A0
INCLEVA	ADDQ.B	#1,(A0)
INCLEVE	RTS
INCSTR1	DC.B	'    PLAYER x    ',0
INCSTR2	DC.B	'AREA XX COMPLETE',0

*
*	BREAK TEST
*
	EVEN
PAUSET	DC.W	0,0,0,0
BREAK	MOVEM.L	A0-A1,-(SP)
	LEA	KEYTAB,A0
	LEA	PAUSET,A1
	TST.B	$43(A0)
	BEQ	BREAKX1
BREAKX2	TST.B	$44(A0)				PAUSE KEY F9/F10
	BEQ	BREAKX2
BREAKX1	TST.B	$3C(A0)
	BEQ	BREAK1
	TST	4(A1)
	BNE	BREAKB
	MOVE	#1,4(A1)
	LEA	SONOFF,A0
	EORI	#1,(A0)
	BRA	BREAKB
BREAK1	CLR	4(A1)
BREAKB	TST.B	$01(A0)
	BEQ	NOBREAK
	TST.B	$2A(A0)			SHIFT AND ESC TO BREAK
	BEQ	NOBREAK
	
	BRA	RESET			EVENTUALLY OK.

NOBREAK	MOVEM.L	(SP)+,A0-A1
	RTS

*
*	KEYBOARD TABLE
*	
	EVEN
KEYTAB	DS.B	300

*
*	CLEAR THE KEYBOARD TABLE
*
CLEARK	LEA	KEYTAB,A0
	MOVE.W	#50,D0
CLEARK1	CLR.W	(A0)+
	DBRA	D0,CLEARK1
	RTS

*
*	KEYBOARD INTERRUPT ROUTINE
*	CLEVER BIT OF CODE.
*
	EVEN
LASTKEY	DC.W	0
KEYNUM	DC.W	0
WAITKB	DC.W	0,0			SECOND WORD IS THAT KEY
*
*	ASCII TRANSLATION TABLE A-Z, SPACE, ENTER, BS, DEL  30-NoS
*
ASCII	DC.B	$1E,$30,$2E,$20,$12,$21,$22,$23,$17,$24
	DC.B	$25,$26,$32,$31,$18,$19,$10,$13,$1F,$14
	DC.B	$16,$2F,$11,$2D,$15,$2C,$39,$1C,$0E,$53	

*
KEYINT	MOVEM.L	D0-D7/A0-A6,-(SP)
KEYTOP	LEA	$FFFC00,A1
	MOVE.B	(A1),D2
	BTST	#7,D2
	BEQ	KEYEND
	BTST	#0,D2
	BEQ	KEYEND
	LEA	KEYTAB,A3
	LEA	WAITKB,A4		REGISTER A KEY PRESSED
	LEA	LASTKEY,A5
	ADD.W	#1,(A4)
	MOVE.B	2(A1),D0
*		CMPI.B	#$FE,D0		 SUSPEND THE JOY 0 OPTION
*		BEQ	JOYPACK
	CMPI.B	#$FF,D0
	BNE	KEYS1
JOYPACK	MOVE	#$6363,(A5)			MARK A KEYBOARD PACKET
	BRA	KEYEND
KEYS1 	CMPI	#$6363,(A5)
	BNE	KEYNORM

JOYSTK	MOVE	#0,(A5)
	CLR.B	$10(A3)				CLEAR QAOP
	CLR.B	$1E(A3)
	CLR.B	$18(A3)
	CLR.B	$19(A3)
	CLR.B	$1C(A3)
	CLR.B	$39(A3)
	MOVE	#$FF,D1
	BTST	#0,D0
	BEQ	JOYS1
	MOVE.B	D1,$10(A3)
JOYS1	BTST	#1,D0
	BEQ	JOYS2
	MOVE.B	D1,$1E(A3)
JOYS2	BTST	#2,D0
	BEQ	JOYS3
	MOVE.B	D1,$18(A3)
JOYS3	BTST	#3,D0
	BEQ	JOYS4
	MOVE.B	D1,$19(A3)
JOYS4	BTST.B	#7,D0
	BEQ	KEYEND
	MOVE.B	D1,$1C(A3)
	MOVE.B	D1,$39(A3)
	BRA	KEYEND

KEYNORM	MOVE	#0,(A5)
	MOVEQ	#0,D1
	BTST	#7,D0
	BNE	KEYINT1
	MOVE	#$FF,D1
	LEA	WAITKB,A4
	MOVE	D0,2(A4)		PUT IN LAST KEY PRESSED
KEYINT1	ANDI.W	#$7F,D0
	MOVE.B	D1,0(A3,D0.W)
KEYEND	BTST	#4,$FFFA01
	BEQ	KEYTOP
	BCLR	#6,$FFFA11
	MOVEM.L	(A7)+,D0-D7/A0-A6
	RTE

*
*	DELAY IN MS, D0 HOLD ms
*
DELAY	MOVE	#799,D7
DELAY1	DBRA	D7,DELAY1
	DBRA	D0,DELAY
	RTS

*
*	READKEY - COVERT FROM SCAN TABLE TO DIR
*

READKEY	LEA	KEYTAB,A0
	CLR.B	$02(A0)				1
	CLR.B	$03(A0)				2
	CLR.B	$1C(A0)				FIRE, (RET)
	CLR.B	$39(A0)				FIRE, (SPACE)
	CLR.B	$10(A0)				Q
	CLR.B	$1E(A0)				A
	CLR.B	$18(A0)				O
	CLR.B	$19(A0)				P
	CLR.B	$17(A0)
	MOVE.B	#$01,$BFE2FF			DATA DIRECTION
	MOVE.B	$BFE0FF,D0
	MOVE	D0,D1
	ANDI.B	#$40,D1
	BNE	NOFIR1
	MOVE.B	#$FF,$17(A0)			INC LEVEL ON MOUSE 1 BUTTON
NOFIR1	ANDI.B	#$80,D0				PORT 2 FIRE BUTTON
	BNE	NOFIRE
	MOVE.B	#$FF,$02(A0)
	MOVE.B	#$FF,$03(A0)
	MOVE.B	#$FF,$1C(A0)
	MOVE.B	#$FF,$39(A0)
NOFIRE	LEA	CUSTOM,A0
	MOVE	JOYDAT1(A0),D0
	LEA	KEYTAB,A0
	MOVE	#9,D1
	BTST	D1,D0
	BEQ	NOLEFT
	MOVE.B	#$FF,$18(A0)
NOLEFT	BTST	#1,D0
	BEQ	NORIGHT
	MOVE.B	#$FF,$19(A0)
NORIGHT	MOVE	D0,D1
	LSR	#1,D1
	EOR	D0,D1
	BTST	#0,D1
	BEQ	NODOWN
	MOVE.B	#$FF,$1E(A0)
NODOWN	ANDI	#$100,D1		EIGTH BIT
	BEQ	NOUP
	MOVE.B	#$FF,$10(A0)
NOUP	MOVEQ	#0,D1
	MOVE	#$19,D0
	BSR	SCAN
	BEQ	READK1
	BSET	#0,D1
READK1	MOVE	#$18,D0
	BSR	SCAN
	BEQ	READK2
	BSET	#1,D1
READK2	MOVE	#$1E,D0
	BSR	SCAN
	BEQ	READK3
	BSET	#2,D1
READK3	MOVE	#$10,D0
	BSR	SCAN
	BEQ	READK4
	BSET	#3,D1
READK4	MOVE	#$39,D0
	BSR	SCAN
	BEQ	READKE
	BSET	#4,D1
READKE	LEA	TABLE,A0
	MOVE.W	DIR(A0),D0
	ANDI	#$80,D0
	OR	D0,D1
	MOVE.W	D1,DIR(A0)		ASSUMING INDIE IS SPRITE 0
	RTS	

*
*	WAITS FOR A KEY TO BE PRESSED
*
WAITK	LEA	WAITKB,A4
	MOVE.W	(A4),D0
WAITKL	CMP.W	(A4),D0
	BEQ	WAITKL
	RTS

*
*	SCAN THE KEYBOARD- CHECK IF SCAN CODE D0 IS PRESSED
*	NZ YES, Z NO
*	
SCAN	MOVE.L	A0,-(SP)


				,ICLEA	KEYTAB,A0
	ANDI.W	#$FF,D0
	MOVE.B	0(A0,D0.W),D0
	MOVE.L	(SP)+,A0
	ANDI.B	#$FF,D0
	RTS


*
*	INCREMENT SCORES   D0-HOLDS
*	10'S & 100'S AND 1000'S ROUTINES
*       
INCTEN	MOVE.W	#4,D1
	BRA	INCGEN
INCHUND	MOVE.W	#3,D1
	BRA	INCGEN
INCTHOU	MOVE.W	#2,D1
INCGEN	LEA	SCORE1,A2
	TST	PLAYWHO
	BEQ	INCGEN2
	LEA	SCORE2,A2
INCGEN2	MOVE	D1,D2				SAVE	D1
INCG21	CMPI.B	#" ",0(A2,D2)
	BNE	INCG22
	MOVE.B	#"0",0(A2,D2)
INCG22	ADDQ	#1,D2
	CMPI	#7,D2
	BNE	INCG21
	MOVE	D1,D2
	BSR	INCGEN3
	MOVE	D2,D1